#include "../../include/error.h"
#include "../../include/pool.h"
#include "../../include/ctx.h"

lm_pkg_t *lm_ctx_find(lm_ctx_t *ctx, char *name, char *version){
  if(NULL == ctx || (NULL == name && NULL == version)){
    lm_error_set(LM_ERR_ArgNULL);
    return NULL;
  }

  lm_pool_t *cur = ctx->pools;
  lm_pkg_t *found = NULL;
  while(cur != NULL){
    if((found = lm_pool_package_find(cur, name, version)) != NULL)
      break;
    cur = cur->next;
  }

  if(NULL == found)
    lm_error_set(LM_ERR_PkgNotFound);
  return found;
}
